            #GIT_CMT=63d744cacf0c97fb1ee4aec6daec771ccacf69b1
%define uek2epoch 2
%define uek4epoch 4
%define uek5epoch 5

%define RELEASE 1.0.5
%{?el7:%define uektag uek4}

Name: ibacm
Epoch: %{uek4epoch}
Version: 1.2.1
Release: %{RELEASE}%{?dist}%{?uektag}
Summary: InfiniBand Communication Manager Assistant

Group: System Environment/Daemons
License: GPLv2 or BSD
Url: http://www.openfabrics.org/
Source0: ibacm-1.2.1.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: autoconf, libtool
BuildRequires: libibverbs-devel >= %{uek4epoch}:1.1.8-1.0.1
BuildRequires: libibverbs-devel < %{uek5epoch}:0
BuildRequires: libibumad-devel >= %{uek4epoch}:1.3.10.2-1.0.1
BuildRequires: libibumad-devel < %{uek5epoch}:0
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
ExcludeArch: s390, s390x

%description
The %{name} daemon helps reduce the load of managing path record lookups on
large InfiniBand fabrics by providing a user space implementation of what
is functionally similar to an ARP cache.  The use of %{name}, when properly
configured, can reduce the SA packet load of a large IB cluster from O(n^2)
to O(n).  The %{name} daemon is started and normally runs in the background,
user applications need not know about this daemon as long as their app
uses librdmacm to handle connection bring up/tear down.  The librdmacm
library knows how to talk directly to the %{name} daemon to retrieve data.

%package devel
Summary: Headers file needed when building apps to talk directly to ibacm.
Requires: %{name} = %{uek4epoch}:%{version}-%{release}
Group: System Environment/Daemons

%description devel
Most applications do not need to know how to talk directly to the ibacm
daemon, but it does have a socket that it listens on, and it has a
specific protocol for incoming/outgoing data.  So if you wish to build
the ability to communicate directly with %{name} into your own application,
the protocol used to communicate with it, and the data structures
involved, are in this header file.  Please note that this is an unsupported
method of using this daemon.  The only supported means of using this is
via librdmacm.  As such, even though this header file is provided, no
further documentation is available.  One must read the source if they
wish to make use of this header file.

%prep
%setup -q -n %{name}-%{version}

%build
mkdir -p config && aclocal -I config && libtoolize --force --copy && autoheader && \
	automake --foreign --add-missing --copy && autoconf
%configure\
	rdmascript="rdma"\
	CFLAGS="$CFLAGS -fno-strict-aliasing"\
	LDFLAGS="$LDFLAGS -lpthread"\
	IBACM_ACME_PLUS_KERNEL_ONLY_DEFAULT="true"
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
install -D -m 755 ibacm.init $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
%makeinstall

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}

%preun
/sbin/chkconfig --del %{name} || true

# Also adding a '%posttrans' section, as the old "ibacm" package
# erroneously removed the service 'ibacm' in its '%preun' section
# for upgrade "if [ $1 = 1 ]".
# This was probably a typo and meant to say "if [ $1 = 0 ]",
# doing it for the uninstall, and not for the upgrade!
# That's water under the bridge though....
# Since '%posttrans' is the only section from a new package
# that is executed AFTER both '%preun' and '%postun' of the
# old package, we do the fixup here.
%posttrans
/sbin/chkconfig --add %{name}

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING README
%{_bindir}/ib_acme
%{_sbindir}/ibacm
%{_mandir}/man1/*
%{_mandir}/man7/*
%{_sysconfdir}/init.d/ibacm
%{_libdir}/ibacm/lib*.*

%files devel
%defattr(-,root,root,-)
%{_includedir}/infiniband/acm.h
%{_includedir}/infiniband/acm_prov.h

%changelog
* Mon Jun 11 2018 Aron Silverton <aron.silverton@oracle.com> - 4:1.2.1-1.0.5
- ibacm: Release v4:1.2.1-1.0.5 (Aron Silverton)  [Orabug: 27593051] [Orabug: 27934606] 
- ibacm: Add "uek4" token to OL7 package (Aron Silverton)  [Orabug: 27934606] 
- ibacm: Add Epoch to package versioning (Aron Silverton)  [Orabug: 27593051] 

* Wed May 16 2018 Aron Silverton <aron.silverton@oracle.com> - 1.2.1-1.0.4
- ibacm: Release v1.2.1-1.0.4 (Aron Silverton)  [Orabug: 28011897] 
- ibacm: Fix service not starting on reboot (Gerd Rausch)  [Orabug: 28011897]

* Wed May 02 2018 Aron Silverton <aron.silverton@oracle.com> - 1.2.1-1.0.3
- ibacm: Release v1.2.1-1.0.3 (Aron Silverton)  [Orabug: 27646071] [Orabug: 27767424] [Orabug: 27788257] 
- ibacm: Adding new configuration option 'acme_plus_kernel_only' (Gerd Rausch)  [Orabug: 27788257] 
- ibacm: Adding new configuration option 'server_mode' (Gerd Rausch)  [Orabug: 27767424] 
- ibacm: Generate autotools output at build time (Aron Silverton)  [Orabug: 27959410] 
- Revert "ibacm: Add files generated by autogen.sh" (Aron Silverton)  [Orabug: 27959410] 
- Revert "ibacm: Add files generated by the configure script" (Aron Silverton)  [Orabug: 27959410] 
- ibacm: empty port provider causes segfault (Wei Lin Guay)  [Orabug: 27646071]

* Mon Aug 21 2017 Aron Silverton <aron.silverton@oracle.com> - 1.2.1-1.0.2
- BUILDINFO: commit=611b8c1721f27f460935db4c07adb13601e3a27d
- ibacm: Bump release number for updates

* Tue Feb 28 2012 Doug Ledford <dledford@redhat.com> - 1.0.5-1
- Ininital version for rhel6
- Related: bz700285

